org.jboss.resteasy.plugins.providers.jaxb

## Class AbstractJAXBProvider<T>

- java.lang.Object
- - org.jboss.resteasy.plugins.providers.AbstractEntityProvider<T>
  - - org.jboss.resteasy.plugins.providers.jaxb.AbstractJAXBProvider<T>

- Type Parameters:
    `T` -
  All Implemented Interfaces:
    MessageBodyReader<T>, MessageBodyWriter<T>
  Direct Known Subclasses:
    JAXBElementProvider, JAXBXmlRootElementProvider, JAXBXmlSeeAlsoProvider, JAXBXmlTypeProvider, XopWithMultipartRelatedJAXBProvider

      public abstract class AbstractJAXBProvider<T>
      extends AbstractEntityProvider<T>

  A AbstractJAXBProvider.
  Version:
    $Revision:$
  Author:
    Ryan J. McDonough

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Providers` | `providers`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractJAXBProvider()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Marshaller` | `decorateMarshaller(Class type, Annotation[] annotations, MediaType mediaType, Marshaller marshaller)`
    `static Unmarshaller` | `decorateUnmarshaller(Class type, Annotation[] annotations, MediaType mediaType, Unmarshaller marshaller)`
    `JAXBContext` | `findJAXBContext(Class<?> type, Annotation[] annotations, MediaType mediaType, boolean reader)`
    `static String` | `getCharset(MediaType mediaType)` FIXME Comment this
    `protected Marshaller` | `getMarshaller(Class<?> type, Annotation[] annotations, MediaType mediaType)` FIXME Comment this
    `boolean` | `isDisableDTDs()`
    `boolean` | `isDisableExternalEntities()`
    `boolean` | `isEnableSecureProcessingFeature()`
    `boolean` | `isReadable(Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Ascertain if the MessageBodyReader can produce an instance of a particular type.
    `protected abstract boolean` | `isReadWritable(Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType)` FIXME Comment this
    `boolean` | `isWriteable(Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Ascertain if the MessageBodyWriter supports a particular type.
    `protected boolean` | `needsSecurity()`
    `protected T` | `processWithSecureProcessing(Unmarshaller unmarshaller, InputStream entityStream, String charset)`
    `T` | `readFrom(Class<T> type, Type genericType, Annotation[] annotations, MediaType mediaType, MultivaluedMap<String,String> httpHeaders, InputStream entityStream)` Read a type from the `InputStream`.
    `static void` | `setCharset(MediaType mediaType, Marshaller marshaller)`
    `void` | `setDisableDTDs(boolean disableDTDs)`
    `void` | `setDisableExternalEntities(boolean disableExternalEntities)`
    `void` | `setEnableSecureProcessingFeature(boolean enableSecureProcessingFeature)`
    `void` | `writeTo(T t, Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType, MultivaluedMap<String,Object> httpHeaders, OutputStream outputStream)` Write a type to an HTTP message.

    - ### Methods inherited from class org.jboss.resteasy.plugins.providers.AbstractEntityProvider

      `getSize`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### providers

          @Context
          protected Providers providers

  - ### Constructor Detail

    - #### AbstractJAXBProvider

          public AbstractJAXBProvider()

  - ### Method Detail

    - #### findJAXBContext

          public JAXBContext findJAXBContext(Class<?> type,
                                    Annotation[] annotations,
                                    MediaType mediaType,
                                    boolean reader)
                                      throws JAXBException

      Throws:
        `JAXBException`

    - #### decorateMarshaller

          public static Marshaller decorateMarshaller(Class type,
                                      Annotation[] annotations,
                                      MediaType mediaType,
                                      Marshaller marshaller)
                                               throws JAXBException

      Throws:
        `JAXBException`

    - #### decorateUnmarshaller

          public static Unmarshaller decorateUnmarshaller(Class type,
                                          Annotation[] annotations,
                                          MediaType mediaType,
                                          Unmarshaller marshaller)
                                                   throws JAXBException

      Throws:
        `JAXBException`

    - #### readFrom

          public T readFrom(Class<T> type,
                   Type genericType,
                   Annotation[] annotations,
                   MediaType mediaType,
                   MultivaluedMap<String,String> httpHeaders,
                   InputStream entityStream)
                     throws IOException

      Description copied from interface: `MessageBodyReader`
      Read a type from the `InputStream`.

      In case the entity input stream is empty, the reader is expected to either return a Java representation of a zero-length entity or throw a `NoContentException` in case no zero-length entity representation is defined for the supported Java type. A `NoContentException`, if thrown by a message body reader while reading a server request entity, is automatically translated by JAX-RS server runtime into a `BadRequestException` wrapping the original `NoContentException` and rethrown for a standard processing by the registered `exception mappers`.

      Parameters:
        `type` - the type that is to be read from the entity stream.
        `genericType` - the type of instance to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Method.getGenericParameterTypes`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Method.getParameterAnnotations`.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - the read-only HTTP headers associated with HTTP entity.
        `entityStream` - the `InputStream` of the HTTP entity. The caller is responsible for ensuring that the input stream ends when the entity has been consumed. The implementation should not close the input stream.
      Returns:
        the type that was read from the stream. In case the entity input stream is empty, the reader is expected to either return an instance representing a zero-length entity or throw a `NoContentException` in case no zero-length entity representation is defined for the supported Java type.
      Throws:
        `IOException` - if an IO error arises. In case the entity input stream is empty and the reader is not able to produce a Java representation for a zero-length entity, `NoContentException` is expected to be thrown.

    - #### writeTo

          public void writeTo(T t,
                     Class<?> type,
                     Type genericType,
                     Annotation[] annotations,
                     MediaType mediaType,
                     MultivaluedMap<String,Object> httpHeaders,
                     OutputStream outputStream)
                       throws IOException

      Description copied from interface: `MessageBodyWriter`
      Write a type to an HTTP message. The message header map is mutable but any changes must be made before writing to the output stream since the headers will be flushed prior to writing the message body.
      Parameters:
        `t` - the instance to write.
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - a mutable map of the HTTP message headers.
        `outputStream` - the `OutputStream` for the HTTP entity. The implementation should not close the output stream.
      Throws:
        `IOException` - if an IO error arises.

    - #### getMarshaller

          protected Marshaller getMarshaller(Class<?> type,
                                 Annotation[] annotations,
                                 MediaType mediaType)

      FIXME Comment this
      Parameters:
        `type` -
        `mediaType` -
        `httpHeaders` -
      Returns:

    - #### setCharset

          public static void setCharset(MediaType mediaType,
                        Marshaller marshaller)
                                 throws PropertyException

      Throws:
        `PropertyException`

    - #### isReadWritable

          protected abstract boolean isReadWritable(Class<?> type,
                               Type genericType,
                               Annotation[] annotations,
                               MediaType mediaType)

      FIXME Comment this
      Parameters:
        `type` -
        `genericType` -
        `annotations` -
      Returns:

    - #### isReadable

          public boolean isReadable(Class<?> type,
                           Type genericType,
                           Annotation[] annotations,
                           MediaType mediaType)

      Description copied from interface: `MessageBodyReader`
      Ascertain if the MessageBodyReader can produce an instance of a particular type. The `type` parameter gives the class of the instance that should be produced, the `genericType` parameter gives the `java.lang.reflect.Type` of the instance that should be produced. E.g. if the instance to be produced is `List<String>`, the `type` parameter will be `java.util.List` and the `genericType` parameter will be `java.lang.reflect.ParameterizedType`.
      Parameters:
        `type` - the class of instance to be produced.
        `genericType` - the type of instance to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Method.getGenericParameterTypes`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Method.getParameterAnnotations`.
        `mediaType` - the media type of the HTTP entity, if one is not specified in the request then `application/octet-stream` is used.
      Returns:
        `true` if the type is supported, otherwise `false`.

    - #### isWriteable

          public boolean isWriteable(Class<?> type,
                            Type genericType,
                            Annotation[] annotations,
                            MediaType mediaType)

      Description copied from interface: `MessageBodyWriter`
      Ascertain if the MessageBodyWriter supports a particular type.
      Parameters:
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written, obtained either by reflection of a resource method return type or via inspection of the returned instance. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
      Returns:
        `true` if the type is supported, otherwise `false`.

    - #### getCharset

          public static String getCharset(MediaType mediaType)

      FIXME Comment this
      Parameters:
        `mediaType` -
      Returns:

    - #### isDisableExternalEntities

          public boolean isDisableExternalEntities()

    - #### setDisableExternalEntities

          public void setDisableExternalEntities(boolean disableExternalEntities)

    - #### isEnableSecureProcessingFeature

          public boolean isEnableSecureProcessingFeature()

    - #### setEnableSecureProcessingFeature

          public void setEnableSecureProcessingFeature(boolean enableSecureProcessingFeature)

    - #### isDisableDTDs

          public boolean isDisableDTDs()

    - #### setDisableDTDs

          public void setDisableDTDs(boolean disableDTDs)

    - #### needsSecurity

          protected boolean needsSecurity()

    - #### processWithSecureProcessing

          protected T processWithSecureProcessing(Unmarshaller unmarshaller,
                                      InputStream entityStream,
                                      String charset)
                                           throws JAXBException

      Throws:
        `JAXBException`

Copyright © 2014. All Rights Reserved.